class TypedCharactersMonitor:
	"""
	Use this class to speak typed characters when application support for this is broken.
	Just call handleChange in event_caret.
	"""

	def __init__(self, obj):
		self._obj=obj
		self._caretY=None
		self._line=None
		self._oldCaretY=None
		self._oldLine=None

	def handleChange(self):
		self._oldCaretY,self._oldLine=self._caretY,self._line
		self._caretY=winUser.getGUIThreadInfo(self._obj.windowThreadID).rcCaret.top
		t=self._obj.makeTextInfo(textInfos.POSITION_CARET)
		t.expand(textInfos.UNIT_LINE)
		self._line=t.text.replace("\0"," ")
		if self._caretY==None or self._caretY!=self._oldCaretY: return
		if len(self._line)-len(self._oldLine)==1:
			t=self._obj.makeTextInfo(textInfos.POSITION_CARET)
			t.move(textInfos.UNIT_CHARACTER,-1)
			t.expand(textInfos.UNIT_CHARACTER)
			ch=t.text
			if ch==" ": speech.speakSpelling(" ") #Space is not spoken for some reason
			else: speech.speakTypedCharacters(ch)
